<StructuredTextModel xmlns="http://schemas.datacontract.org/2004/07/Omron.Cxap.Modules.StructuredText.Core" xmlns:i="http://www.w3.org/2001/XMLSchema-instance"><Text>//-----------------------------------------------------------------------------------&#xD;
//                                    Modbus TCP Client Fn03 Read&#xD;
// __________________________________________________________________________________&#xD;
&#xD;
&#xD;
Check_StepTime(In:=TCP_Step=2, PT:=T#5s);&#xD;
IF Check_StepTime.Q THEN	 // Check if Receive not executed and fixed in step 2&#xD;
	Sending:=		FALSE;&#xD;
	TCP_Step:=		0;&#xD;
	Check_StepTime.In:=FALSE;&#xD;
END_IF;&#xD;
&#xD;
CASE TCP_Step OF&#xD;
	&#xD;
	0:	//  Waiting for Send Request INPUT&#xD;
	IF Enable THEN&#xD;
			IF Send_Request AND NOT Sending AND Register_Qty &gt;0 THEN&#xD;
				Sending						:=TRUE;&#xD;
				TCP_Step						:=INT#1;&#xD;
				TCP_Recv_Inst(Execute:=FALSE,RcvDat :=Recv_Data[0]);&#xD;
				TCP_Send_Inst(Execute:=FALSE, SendDat:=Send_Data[0]);&#xD;
				Error								:=FALSE;&#xD;
				ErrorID							:=16#0;&#xD;
				TCP_ClearBuf_Inst(Execute:=TRUE);&#xD;
			END_IF;&#xD;
			IF NOT Send_Request THEN Cmd_Ok:=FALSE;END_IF;&#xD;
	ELSE&#xD;
			Cmd_Ok	:=FALSE;&#xD;
			Error			:=FALSE;&#xD;
			ErrorID		:=0;&#xD;
	END_IF;		&#xD;
	&#xD;
	1: //  Send request ----------------------------------------------------------------		&#xD;
		&#xD;
		// Initialize MBAP header&#xD;
		Send_Data[0]						:= 16#00;&#xD;
		Send_Data[1]						:= 16#00;&#xD;
		Send_Data[2]						:= 16#00;&#xD;
		Send_Data[3]						:= 16#00;&#xD;
		Send_Data[4]						:= 16#00;&#xD;
		Send_Data[5]						:= 16#06;								// length (fixed)		&#xD;
		Send_Data[6]						:= Unit_ID;							// Unit identifier&#xD;
		Send_Data[7]						:= 16#03;								// function code Read Register&#xD;
		ToAryByte(Register_Address,_HIGH_LOW,Send_Data[8]);&#xD;
		ToAryByte(Register_Qty,_HIGH_LOW,Send_Data[10]);&#xD;
		Expected_Length					:= UINT_TO_BYTE(Register_Qty *2 + 3);&#xD;
&#xD;
		TCP_Send_Inst(	Execute:=TRUE,									// --&gt; send request&#xD;
						Socket					:=TCP_Socket,&#xD;
						SendDat				:=Send_Data[0],&#xD;
						Size						:=UINT#12);&#xD;
						&#xD;
		IF (TCP_Send_Inst.Done) THEN&#xD;
			TCP_Step							:=2;	&#xD;
			TCP_Send_Inst(Execute:=FALSE, SendDat:=Send_Data[0]);&#xD;
&#xD;
		ELSIF (TCP_Send_Inst.Error) THEN&#xD;
			Error									:=TRUE;&#xD;
			ErrorID								:=TCP_Send_Inst.ErrorID;&#xD;
			TCP_Step							:=3;&#xD;
			TCP_Send_Inst(Execute:=FALSE, SendDat:=Send_Data[0]);&#xD;
&#xD;
		END_IF;&#xD;
&#xD;
&#xD;
	2:	// Receive response --------------------------------------------------------------&#xD;
&#xD;
		TCP_Recv_Inst(	Execute:=TRUE,&#xD;
				Socket					:=TCP_Socket,&#xD;
				Timeout				:=UINT#100,											// Timeout fixed to 10s&#xD;
				Size						:=UINT#255,&#xD;
				RcvDat					:= Recv_Data[0]);&#xD;
					&#xD;
		IF (TCP_Recv_Inst.Done)  THEN &#xD;
			&#xD;
			IF Recv_Data[7]=16#83 THEN												// Modbus Exception Error&#xD;
				Error								:=TRUE;&#xD;
				ErrorID							:=Recv_Data[8];							&#xD;
			ELSIF (Recv_Data[5] = Expected_Length) THEN&#xD;
				AryByteTo(Recv_Data[9],BYTE_TO_UINT(Recv_Data[8]) ,_HIGH_LOW,Register);&#xD;
				Cmd_Ok:=	TRUE;			&#xD;
			END_IF;			&#xD;
			TCP_Step:=		3;&#xD;
			&#xD;
		ELSIF (TCP_Recv_Inst.Error) THEN &#xD;
			Error:=			TRUE;&#xD;
			ErrorID:=		TCP_Recv_Inst.ErrorID;											// Receive Error (2006=Timeout)&#xD;
			TCP_Recv_Inst(Execute:=FALSE,RcvDat :=Recv_Data[0]);&#xD;
			TCP_Step:=	3;&#xD;
			&#xD;
		END_IF;	&#xD;
		&#xD;
&#xD;
	3:	//Finished -----------------------------------------------------------------------		&#xD;
	&#xD;
		IF NOT Send_Request THEN &#xD;
			Sending:=	FALSE; &#xD;
			TCP_Step:=	0;&#xD;
		END_IF;&#xD;
&#xD;
&#xD;
END_CASE;&#xD;
&#xD;
&#xD;
&#xD;
&#xD;
</Text></StructuredTextModel>